<?php
class ControllerExtensionPaymentTcbpay extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/tcbpay');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_tcbpay', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['username'])) {
			$data['error_username'] = $this->error['username'];
		} else {
			$data['error_username'] = '';
		}

		if (isset($this->error['password'])) {
			$data['error_password'] = $this->error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset($this->error['secretkey'])) {
			$data['error_secretkey'] = $this->error['secretkey'];
		} else {
			$data['error_secretkey'] = '';
		}

		if (isset($this->error['card_types'])) {
			$data['error_cctypes'] = $this->error['card_types'];
		} else {
			$data['error_cctypes'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/tcbpay', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/tcbpay', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_tcbpay_status'])) {
			$data['payment_tcbpay_status'] = $this->request->post['payment_tcbpay_status'];
		} else {
			$data['payment_tcbpay_status'] = $this->config->get('payment_tcbpay_status');
		}

		if (isset($this->request->post['payment_tcbpay_testmode'])) {
			$data['payment_tcbpay_testmode'] = $this->request->post['payment_tcbpay_testmode'];
		} else {
			$data['payment_tcbpay_testmode'] = $this->config->get('payment_tcbpay_testmode');
		}

		if (isset($this->request->post['payment_tcbpay_username'])) {
			$data['payment_tcbpay_username'] = $this->request->post['payment_tcbpay_username'];
		} else {
			$data['payment_tcbpay_username'] = $this->config->get('payment_tcbpay_username');
		}

		if (isset($this->request->post['payment_tcbpay_password'])) {
			$data['payment_tcbpay_password'] = $this->request->post['payment_tcbpay_password'];
		} else {
			$data['payment_tcbpay_password'] = $this->config->get('payment_tcbpay_password');
		}

		if (isset($this->request->post['payment_tcbpay_secretkey'])) {
			$data['payment_tcbpay_secretkey'] = $this->request->post['payment_tcbpay_secretkey'];
		} else {
			$data['payment_tcbpay_secretkey'] = $this->config->get('payment_tcbpay_secretkey');
		}

		if (isset($this->request->post['payment_tcbpay_cctypes'])) {
			$data['payment_tcbpay_cctypes'] = $this->request->post['payment_tcbpay_cctypes'];
		} else {
			$data['payment_tcbpay_cctypes'] = $this->config->get('payment_tcbpay_cctypes');
		}

		if (isset($this->request->post['payment_tcbpay_usecvv'])) {
			$data['payment_tcbpay_usecvv'] = $this->request->post['payment_tcbpay_usecvv'];
		} else {
			$data['payment_tcbpay_usecvv'] = $this->config->get('payment_tcbpay_usecvv');
		}

		if (isset($this->request->post['payment_tcbpay_total'])) {
			$data['payment_tcbpay_total'] = $this->request->post['payment_tcbpay_total'];
		} else {
			$data['payment_tcbpay_total'] = $this->config->get('payment_tcbpay_total');
		}

		if (isset($this->request->post['payment_tcbpay_order_status_id'])) {
			$data['payment_tcbpay_order_status_id'] = $this->request->post['payment_tcbpay_order_status_id'];
		} else {
			$data['payment_tcbpay_order_status_id'] = $this->config->get('payment_tcbpay_order_status_id');
		}

		$data['cctypes'] = [
			['value' => 'AE', 'label' => $this->language->get('text_american_express')],
			['value' => 'VI', 'label' => $this->language->get('text_visa')],
			['value' => 'MC', 'label' => $this->language->get('text_mastercard')],
			['value' => 'DI', 'label' => $this->language->get('text_discover')],
			['value' => 'JCB', 'label' => $this->language->get('text_jcb')],
			['value' => 'OT', 'label' => $this->language->get('text_other')],
		];

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_tcbpay_geo_zone_id'])) {
			$data['payment_tcbpay_geo_zone_id'] = $this->request->post['payment_tcbpay_geo_zone_id'];
		} else {
			$data['payment_tcbpay_geo_zone_id'] = $this->config->get('payment_tcbpay_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_tcbpay_sort_order'])) {
			$data['payment_tcbpay_sort_order'] = $this->request->post['payment_tcbpay_sort_order'];
		} else {
			$data['payment_tcbpay_sort_order'] = $this->config->get('payment_tcbpay_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/tcbpay', $data));
	}

	public function install() {
		$this->load->model('extension/payment/tcbpay');
		$this->model_extension_payment_tcbpay->install();
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/tcbpay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!isset($this->request->post['payment_tcbpay_cctypes'])) {
			$this->error['card_types'] = $this->language->get('error_cctypes');
		}

		if (!$this->request->post['payment_tcbpay_username']) {
			$this->error['username'] = $this->language->get('error_username');
		}

		if (!$this->request->post['payment_tcbpay_password']) {
			$this->error['password'] = $this->language->get('error_password');
		}

		if (!$this->request->post['payment_tcbpay_secretkey']) {
			$this->error['secretkey'] = $this->language->get('error_secretkey');
		}

		return !$this->error;
	}
}